#/usr/bin/python
# -*- coding: utf-8 -*-

import defaults as DEF

from ..utilities import normalize
from scipy import array, cross, ndarray

class Camera(object):
	def __init__(self, pos = DEF.pos, dir = DEF.dir, focalLength = DEF.focallength, \
					angle = DEF.angle, aspectRatio = DEF.aspectratio, sky = DEF.sky):
		
		self.pos			= pos
		self.dir			= normalize(dir)
		self.focalLength	= focalLength
		self.angle			= angle
		self.aspectRatio	= aspectRatio
		
		self.setSky(sky)
	
	def setSky(self, sky):
		if type(sky) == ndarray:
			self.sky = sky
		else:
			self.sky = normalize(cross(cross(self.dir, array([0, 0, 1])), self.dir))
		
	def __str__(self):
		return 'Camera Object:\nPOSITION:\t\t%s\nDIR:\t\t\t\t\t%s\nFocal Length:\t%s\nAngel:\t\t\t\t%s\nAspectRatio:\t%s\nsky:\t\t\t\t\t%s' % (str(self.pos), str(self.dir), str(self.focalLength), str(self.angle), str(self.aspectRatio), str(self.sky))

import logging

logging.debug("camera module was successfully loaded")

