#/usr/bin/python
# -*- coding: utf-8 -*-

from meta import GeometricalObject
from pointsOfIntersection import PointsOfIntersection
from scipy import array

class Intersection(GeometricalObject):
	def __init__(self, pos, dir = None, scale = None, objs = []):
		GeometricalObject.__init__(self, pos, dir, scale)
		self.objs = list(objs)
	
	def intersectionWithRay(self, ray):
		points = PointsOfIntersection(ray)
		
		for obj in self.objs:
			otherObjects = self.objs[:]
			del otherObjects[self.objs.index(obj)]
			
			inter = obj.intersectionWithRay(ray).getAllBeyondRayStart()
			
			if len(inter) > 0:
				pointsPartOfAllObjects = []
				for p in inter.points:
					partOfAllObjects = True
					for otherObj in otherObjects: 
						if otherObj.pointIsPartOf(ray.getPoint(p.dist)) is not True:
							partOfAllObjects = False
							break
					if partOfAllObjects:
						points.append(p)
		
		return points
	
	def pointIsPartOf(self, point):
		partOfAllObjects = True
		for obj in self.objs: 
			if obj.pointIsPartOf(point) is not True:
				partOfAllObjects = False
				break
		
		return partOfAllObjects
